(function (thisObj) {
// ----- EXTENDSCRIPT INCLUDES ------ //
"object"!=typeof JSON&&(JSON={}),function(){"use strict";var rx_one=/^[\],:{}\s]*$/,rx_two=/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,rx_three=/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,rx_four=/(?:^|:|,)(?:\s*\[)+/g,rx_escapable=/[\\\"\u0000-\u001f\u007f-\u009f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,rx_dangerous=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,gap,indent,meta,rep;function f(t){return t<10?"0"+t:t}function this_value(){return this.valueOf()}function quote(t){return rx_escapable.lastIndex=0,rx_escapable.test(t)?'"'+t.replace(rx_escapable,function(t){var e=meta[t];return"string"==typeof e?e:"\\u"+("0000"+t.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+t+'"'}function str(t,e){var r,n,o,u,f,a=gap,i=e[t];switch(i&&"object"==typeof i&&"function"==typeof i.toJSON&&(i=i.toJSON(t)),"function"==typeof rep&&(i=rep.call(e,t,i)),typeof i){case"string":return quote(i);case"number":return isFinite(i)?String(i):"null";case"boolean":case"null":return String(i);case"object":if(!i)return"null";if(gap+=indent,f=[],"[object Array]"===Object.prototype.toString.apply(i)){for(u=i.length,r=0;r<u;r+=1)f[r]=str(r,i)||"null";return o=0===f.length?"[]":gap?"[\n"+gap+f.join(",\n"+gap)+"\n"+a+"]":"["+f.join(",")+"]",gap=a,o}if(rep&&"object"==typeof rep)for(u=rep.length,r=0;r<u;r+=1)"string"==typeof rep[r]&&(o=str(n=rep[r],i))&&f.push(quote(n)+(gap?": ":":")+o);else for(n in i)Object.prototype.hasOwnProperty.call(i,n)&&(o=str(n,i))&&f.push(quote(n)+(gap?": ":":")+o);return o=0===f.length?"{}":gap?"{\n"+gap+f.join(",\n"+gap)+"\n"+a+"}":"{"+f.join(",")+"}",gap=a,o}}"function"!=typeof Date.prototype.toJSON&&(Date.prototype.toJSON=function(){return isFinite(this.valueOf())?this.getUTCFullYear()+"-"+f(this.getUTCMonth()+1)+"-"+f(this.getUTCDate())+"T"+f(this.getUTCHours())+":"+f(this.getUTCMinutes())+":"+f(this.getUTCSeconds())+"Z":null},Boolean.prototype.toJSON=this_value,Number.prototype.toJSON=this_value,String.prototype.toJSON=this_value),"function"!=typeof JSON.stringify&&(meta={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"},JSON.stringify=function(t,e,r){var n;if(gap="",indent="","number"==typeof r)for(n=0;n<r;n+=1)indent+=" ";else"string"==typeof r&&(indent=r);if(rep=e,e&&"function"!=typeof e&&("object"!=typeof e||"number"!=typeof e.length))throw new Error("JSON.stringify");return str("",{"":t})}),"function"!=typeof JSON.parse&&(JSON.parse=function(text,reviver){var j;function walk(t,e){var r,n,o=t[e];if(o&&"object"==typeof o)for(r in o)Object.prototype.hasOwnProperty.call(o,r)&&(void 0!==(n=walk(o,r))?o[r]=n:delete o[r]);return reviver.call(t,e,o)}if(text=String(text),rx_dangerous.lastIndex=0,rx_dangerous.test(text)&&(text=text.replace(rx_dangerous,function(t){return"\\u"+("0000"+t.charCodeAt(0).toString(16)).slice(-4)})),rx_one.test(text.replace(rx_two,"@").replace(rx_three,"]").replace(rx_four,"")))return j=eval("("+text+")"),"function"==typeof reviver?walk({"":j},""):j;throw new SyntaxError("JSON.parse")})}();
// ---------------------------------- //
// ----- EXTENDSCRIPT PONYFILLS -----
function __objectFreeze(obj) { return obj; }
// ---------------------------------- //
// Fixed namespace to avoid ExtendScript environment issues
var ns = "__CLIPLO__";

var createJCuts = function createJCuts(amountOfFrames, type) {
  app.enableQE();
  var seq = app.project.activeSequence;
  var qeSeq = qe.project.getActiveSequence();
  var audioTrack = qeSeq.getAudioTrackAt(0);
  var videoTrack = qeSeq.getVideoTrackAt(0);
  var regularVideoTrack = seq.videoTracks[0];
  var regularAudioTrack = seq.audioTracks[0];
  var seqSettings = seq.getSettings();
  //alert(JSON.stringify(seqSettings.videoFrameRate));
  var fps = seqSettings.videoFrameRate.seconds;
  var jcutOffset = fps * amountOfFrames * -1;
  
  var amountOfClips = regularVideoTrack.clips.length;
  var clips = [];
  for (var i = 0; i < amountOfClips; i++) {
    var qeVideoClip = videoTrack.getItemAt(i);
    var qeAudioClip = audioTrack.getItemAt(i);
    var regVideoClip = regularVideoTrack.clips[i];
    var regAudioClip = regularAudioTrack.clips[i];
    clips.push({
      qeVideoClip: qeVideoClip,
      qeAudioClip: qeAudioClip,
      regVideoClip: regVideoClip,
      regAudioClip: regAudioClip
    });
  }
  for (var i = 1; i < clips.length; i++) {
    // Calculate move distance
    var moveDistance = i * jcutOffset;

    // Get items
    var prev = clips[i - 1];
    var curr = clips[i];

    // Move Videotrack up
    if (type === "j") {
      
      prev.qeVideoClip.moveToTrack(1, 0, "0");
    } else {
      
      curr.qeVideoClip.moveToTrack(1, 0, "0");
    }

    // Move audio track down
    if (i % 2 !== 0) {
      
      curr.qeAudioClip.moveToTrack(-1, 1, "0");
    }

    // Move both items left by move distance
    
    curr.regVideoClip.move(moveDistance);
    
    curr.regAudioClip.move(moveDistance);

    // Move video track back down
    if (type === "j") {
      
      prev.qeVideoClip.moveToTrack(-1, 1, "0");
    } else {
      
      curr.qeVideoClip.moveToTrack(-1, 1, "0");
    }
  }
};

var backupActiveSequence = function backupActiveSequence() {
  var seq = app.project.activeSequence;
  if (!seq) return null;

  // Find or create Cliplo Backup bin
  var backupBin = null;
  for (var i = 0; i < app.project.rootItem.children.numItems; i++) {
    var item = app.project.rootItem.children[i];
    if (item.name === "Cliplo Backup" && item.type === ProjectItemType.BIN) {
      backupBin = item;
      break;
    }
  }
  if (!backupBin) {
    backupBin = app.project.rootItem.createBin("Cliplo Backup");
  }

  // Store original sequence info
  seq.sequenceID;

  // Create timestamp for the backup name
  var now = new Date();
  var timestamp = now.toUTCString();
  var backupName = "".concat(seq.name, " - Backup ").concat(timestamp);

  // Clone the sequence
  var cloneSuccess = seq.clone();
  if (!cloneSuccess) return null;

  // Find the newly created sequence (it will have " Copy" appended)
  var duplicatedSeq = null;
  for (var _i = 0; _i < app.project.sequences.numSequences; _i++) {
    var sequence = app.project.sequences[_i];
    if (sequence.name === "".concat(seq.name, " Copy")) {
      duplicatedSeq = sequence;
      break;
    }
  }
  if (!duplicatedSeq) return null;

  // Rename and move to backup bin
  duplicatedSeq.name = backupName;

  // Find the ProjectItem for the sequence to move it
  var sequenceProjectItem = null;
  for (var _i2 = 0; _i2 < app.project.rootItem.children.numItems; _i2++) {
    var _item = app.project.rootItem.children[_i2];
    if (_item.name === backupName) {
      sequenceProjectItem = _item;
      break;
    }
  }
  if (sequenceProjectItem) {
    sequenceProjectItem.moveBin(backupBin);
  }

  // Close the backup sequence and refocus the original
  duplicatedSeq.close();
  app.project.openSequence(seq.sequenceID);
  return {
    backupName: backupName,
    originalSequenceId: seq.sequenceID
  };
};

var exportAudio = function exportAudio(audioPath, eprPath) {
  app.project.activeSequence.exportAsMediaDirect(audioPath, eprPath, 0);
};

var getPath = function getPath() {
  return app.project.path;
};

var removeSilences = function removeSilences(silences) {
  // Enable QE for additional features
  app.enableQE();

  //alert(`Initially passed silences: ${JSON.stringify(silences)}`);

  // Set up sequence variables
  var seq = app.project.activeSequence;
  var qeSeq = qe.project.getActiveSequence();
  var seqSettings = seq.getSettings();

  // Get frame rate and display format
  var fpsTime = seqSettings.videoFrameRate;
  var frameDuration = fpsTime.seconds;
  var fps = 1 / frameDuration;

  //alert(`Frame rate: ${fps}`);
  //alert(`Frame duration: ${frameDuration}`);

  var displayFormat = seqSettings.videoDisplayFormat;

  // Frame alignment function
  var alignToFrames = function alignToFrames(seconds) {
    return Math.round(seconds * fps) / fps;
  };

  // Adjust silences to frame boundaries
  var frameAlignedSilences = [];
  for (var i = 0; i < silences.length; i++) {
    var _silence = silences[i];
    var alignedStart = alignToFrames(_silence.start);
    var alignedEnd = alignToFrames(_silence.end);

    // Ensure minimum 1 frame duration
    if (alignedEnd - alignedStart < frameDuration) {
      alignedEnd = alignedStart + frameDuration;
    }
    frameAlignedSilences.push({
      start: alignedStart,
      end: alignedEnd,
      duration: alignedEnd - alignedStart
    });
  }

  //alert(`Frame-aligned silences: ${JSON.stringify(frameAlignedSilences)}`);

  var initialClips = [];
  var videoClips = seq.videoTracks[0].clips;
  for (var v = 0; v < videoClips.numItems; v++) {
    var clip = videoClips[v];
    initialClips.push({
      start: clip.start.seconds,
      end: clip.end.seconds
    });
  }

  //alert(`Initial clips before razor: ${JSON.stringify(initialClips)}`);

  // Create cuts at frame-aligned boundaries
  var cutAt = function cutAt(pos) {
    var time = new Time();
    time.seconds = pos;
    var startFrame = time.getFormatted(fpsTime, displayFormat);
    
    qeSeq.razor(startFrame);
  };
  for (var s = 0; s < frameAlignedSilences.length; s++) {
    var silence = frameAlignedSilences[s];
    cutAt(silence.start);
    cutAt(silence.end);
  }

  // Frame-accurate clip checking
  var isClipInSilence = function isClipInSilence(clipStart, clipEnd) {
    var tolerance = frameDuration / 2; // Half-frame tolerance
    for (var i = 0; i < frameAlignedSilences.length; i++) {
      var silence = frameAlignedSilences[i];

      // Check if clip is fully contained within silence with tolerance
      var clipStartsInSilence = clipStart + tolerance >= silence.start;
      var clipEndsInSilence = clipEnd - tolerance <= silence.end;
      if (clipStartsInSilence && clipEndsInSilence) {
        return true;
      }
    }
    return false;
  };
  var finalClips = [];
  var removedClips = [];

  // Process video tracks first (no ripple)
  for (var vTrack = 0; vTrack < seq.videoTracks.numTracks; vTrack++) {
    var videoClips = seq.videoTracks[vTrack].clips;
    for (var v = videoClips.numItems - 1; v >= 0; v--) {
      var clip = videoClips[v];
      finalClips.push({
        start: clip.start.seconds,
        end: clip.end.seconds
      });
      if (isClipInSilence(clip.start.seconds, clip.end.seconds)) {
        clip.remove(false, false);
        removedClips.push({
          start: clip.start.seconds,
          end: clip.end.seconds
        });
      }
    }
  }

  //alert(`Final clips after razor: ${JSON.stringify(finalClips)}`);
  //alert(`Removed clips: ${JSON.stringify(removedClips)}`);

  // Process audio tracks after (with ripple)
  for (var aTrack = 0; aTrack < seq.audioTracks.numTracks; aTrack++) {
    var audioClips = seq.audioTracks[aTrack].clips;
    for (var a = audioClips.numItems - 1; a >= 0; a--) {
      var clip = audioClips[a];
      if (isClipInSilence(clip.start.seconds, clip.end.seconds)) {
        clip.remove(true, false);
      }
    }
  }
};

var findProjectItemRecursive = function findProjectItemRecursive(root, name, parent) {
  for (var i = 0; i < root.children.numItems; i++) {
    var item = root.children[i];
    if (item.name === name) {
      return {
        item: item,
        parent: parent
      };
    }

    // If this is a bin, search inside it
    if (item.type === ProjectItemType.BIN) {
      var found = findProjectItemRecursive(item, name, item);
      if (found) return found;
    }
  }
  return null;
};
var restoreBackup = function restoreBackup(backupName, originalSequenceId) {
  // Find the original sequence by ID
  var originalSequence = null;
  for (var i = 0; i < app.project.sequences.numSequences; i++) {
    var sequence = app.project.sequences[i];
    if (sequence.sequenceID === originalSequenceId) {
      originalSequence = sequence;
      break;
    }
  }
  if (!originalSequence) return null;
  var originalName = originalSequence.name;
  var rootItem = app.project.rootItem;

  // Find the current sequence and its parent
  var currentFound = findProjectItemRecursive(rootItem, originalName, rootItem);
  if (!currentFound) return null;

  // Find the backup sequence and its parent
  var backupFound = findProjectItemRecursive(rootItem, backupName, rootItem);
  if (!backupFound) return null;
  currentFound.item;
    var originalBin = currentFound.parent;
  var backupItem = backupFound.item;

  // Delete the current sequence
  //currentItem.select();
  app.project.deleteSequence(originalSequence);

  // Move backup to original location and rename it
  backupItem.moveBin(originalBin);
  backupItem.name = originalName;

  // Open the restored sequence
  for (var _i = 0; _i < app.project.sequences.numSequences; _i++) {
    var _sequence = app.project.sequences[_i];
    if (_sequence.name === originalName) {
      app.project.openSequence(_sequence.sequenceID);
      break;
    }
  }
  return {
    success: true,
    restoredName: originalName
  };
};

var ppro = /*#__PURE__*/__objectFreeze({
  __proto__: null,
  createJCuts: createJCuts,
  backupActiveSequence: backupActiveSequence,
  exportAudio: exportAudio,
  getPath: getPath,
  removeSilences: removeSilences,
  restoreBackup: restoreBackup
});

var host = typeof $ !== "undefined" ? $ : window;
switch (BridgeTalk.appName) {
  case "premierepro":
  case "premiereprobeta":
    host[ns] = ppro;
    break;
}

// https://extendscript.docsforadobe.dev/interapplication-communication/bridgetalk-class.html?highlight=bridgetalk#appname

})(this);